/***********************************
    Created By : Beycan Kahraman
************************************/

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define ARALIK 400
#define MAX_DENKLEM 10
#define HATA_PAYI 0.00001
#define MAX_ADIM 50

using namespace std;

float P(float x){
      return pow(x,10) - 671*pow(x,9)/105 - 785*pow(x,8)/336 + 149011*pow(x,7)/1680 - 
             125539*pow(x,6)/960 - 27287*pow(x,5)/96 - 715697*pow(x,4)/960 - 
             13277*pow(x,3)/280 - 271857*pow(x,2)/280 + 4878*x/7 - 405.0/4;
}

float dP(float x){
      return 10*pow(x,9) - 9*671*pow(x,8)/105 - 8*785*pow(x,7)/336 + 7*149011*pow(x,6)/1680 - 
             6*125539*pow(x,5)/960 - 5*27287*pow(x,4)/96 - 4*715697*pow(x,3)/960 - 
             3*13277*pow(x,2)/280 - 2*271857*x/280 + 4878/7;
}

int main(){
    FILE *f;
    double x[MAX_DENKLEM], basx, sonx, kok[MAX_DENKLEM];
    int sayac = 5, ADIM;
    
    x[0] = -4;
    x[1] = 0;
    x[2] = 0.25;
    x[3] = 4;
    x[4] = 6;
    
    f = fopen("MyBisection.txt", "w");
    fprintf(f,"========== BISECTION YONTEMI ======================================================\n\n");
    fprintf(f,"Deneme Noktalari : \tA(%f, \t%f), \n\t\t\tB(%f, \t%f), \n\t\t\tC(%f, \t%f), \n\t\t\tD(%f, \t%f), \n\t\t\tE(%f, \t%f)\n\n", x[0], P(x[0]), x[1], P(x[1]), x[2], P(x[2]), x[3], P(x[3]), x[4], P(x[4]));
    fprintf(f,"===================================================================================\n\n");
    fprintf(f,"ILK\t\tSON\t\tP(ILK)\t\tP(SON)\n");
    fprintf(f,"---\t\t---\t\t------\t\t------\n\n");
    for(int i=0; i<sayac-1; i++){
        basx = x[i] < x[i+1] ? x[i] : x[i+1];
        sonx = x[i] > x[i+1] ? x[i] : x[i+1];
        ADIM = 0;
        fprintf(f,"\n------------------------------------\n");
        fprintf(f,"x1 = %f,  x2 = %f\n", basx, sonx);
        fprintf(f,"------------------------------------\n\n");
        while( fabs(sonx - basx) > HATA_PAYI && ADIM < MAX_ADIM){
            ADIM++;
            fprintf(f,"%f\t%f\t%f\t%f\n",basx,sonx,P(basx),P(sonx));
            if( P( basx ) * P( (basx+sonx)/2 ) < 0 )
                sonx = (basx+sonx)/2;
            else
                basx = (basx+sonx)/2;
        }
        kok[i] = basx;
        fprintf(f,"\nBulunan Yaklasik Kok = %f\n\n", kok[i]);
    }
    fclose(f);
    
    f = fopen("MyNewton.txt", "w");
    fprintf(f,"========== NEWTON RAPHSON YONTEMI =================================================\n\n");
    fprintf(f,"Baslangic Noktalari : \tA(%f, \t%f), \n\t\t\tB(%f, \t%f), \n\t\t\tC(%f, \t%f), \n\t\t\tD(%f, \t%f), \n\t\t\tE(%f, \t%f)\n\n", x[0], P(x[0]), x[1], P(x[1]), x[2], P(x[2]), x[3], P(x[3]), x[4], P(x[4]));
    fprintf(f,"===================================================================================\n\n");
    fprintf(f,"KOK\t\tP(KOK)\t\tdP(KOK)\n");
    fprintf(f,"---\t\t------\t\t-------\n\n");
    for(int i=0; i<sayac; i++){
        kok[i] = x[i];
        ADIM = 0;
        fprintf(f,"\n------------------------------------\n");
        fprintf(f,"x = %f\n", kok[i]);
        fprintf(f,"------------------------------------\n\n");
        while( fabs(P(kok[i])/dP(kok[i])) > HATA_PAYI && ADIM < MAX_ADIM){
            ADIM++;
            fprintf(f,"%f\t%f\t%f\n", kok[i], P(kok[i]), dP(kok[i]));
            kok[i] = kok[i] - P(kok[i])/dP(kok[i]);
        }
        fprintf(f,"\nBulunan Yaklasik Kok = %f\n\n", kok[i]);
    }
    fclose(f);
    x[0] = -10;
    x[1] = -4;
    x[2] = 5;
    x[4] = 10;
    x[5] = 15;
    sayac = 6;
    f = fopen("MySecant.txt", "w");
    fprintf(f,"========== SECANT YONTEMI =========================================================\n\n");
    fprintf(f,"Baslangic Noktalari : \tA(%f, \t%f), \n\t\t\tB(%f, \t%f), \n\t\t\tC(%f, \t%f), \n\t\t\tD(%f, \t%f), \n\t\t\tE(%f, \t%f)\n\n", x[0], P(x[0]), x[1], P(x[1]), x[2], P(x[2]), x[3], P(x[3]), x[4], P(x[4]));
    fprintf(f,"===================================================================================\n\n");
    fprintf(f,"KOK\t\tP(KOKn)\t\tP(KOKn-1)\n");
    fprintf(f,"---\t\t------\t\t-------\n\n");
    for(int i=0; i<sayac-1; i++){
        kok[i] = x[i+1];
        ADIM = 0;
        basx = x[i];
        fprintf(f,"\n------------------------------------\n");
        fprintf(f,"p0 = %f,  p1 = %f\n", basx, kok[i]);
        fprintf(f,"------------------------------------\n\n");
        while( fabs((kok[i] - sonx)*P(kok[i])/(P(kok[i]) - P(sonx))) > HATA_PAYI && ADIM < MAX_ADIM){
            ADIM++;
            sonx = basx;
            basx = kok[i];
            fprintf(f,"%f\t%f\t%f\n", kok[i], P(kok[i]), P(sonx));
            kok[i] = kok[i] - (kok[i] - sonx)*P(kok[i])/(P(kok[i]) - P(sonx));
        }
        fprintf(f,"\nBulunan Yaklasik Kok = %f\n\n", kok[i]);
    }
    fclose(f);
    
    cout << "===========  ISTENEN ISLEM BASARIYLA GERCEKLESTIRILDI  ==============\n\n";
    cout << " MyBisection.txt, MyNewton.txt ve MySecant.txt dosyalari olusturuldu\n\n";
    cout << "=====================================================================\n\n";
    cout << "\t\t\t\t\t\tBeycan Kahraman\n\t\t\t\t\t\t040020337\n\n";
    
    system("PAUSE");
    return 0;
}
